%% One Frame Segmentation / splitting highways. This files allow to segment the images.
%%Several parameters come out of the file : newB = Contours (coordinate)
% final_single_cell_indices = Indices of single cell in newB
% working_indices = Indices of contours that were not classified
% slopevector = were the profiles were traced
% newboundarea = area of the contour
% maxvalues2 = maximal intensity values over the profile
% minvalues2 = minimal intensity values over the profile
% centroid = Center of mass of the cell
% longueur_profile = Length of the profile
% texture = texture parameters within the contours.
% back_ground = List of background indices
% round_cells = List of round cells
% highway_indices = indices of highway classified values
% level2 = value of the threshold along the axis. Used for the segmentation refinement);




mainDirectory = '/'; % Main Directory in which subsequent steps will be saved
dirImage = dir(fullfile(mainDirectory,'*.tif')); % List Images in the directory
loadingDirectory = fullfile(mainDirectory, '');
savefiledirectory = fullfile(mainDirectory, 'seg_results'); % Saving results folder
mkdir(savefiledirectory);
logDirectory = fullfile(mainDirectory, 'logs');% Logs file Directory
log_file2 = fopen(fullfile(logDirectory, 'log_segmentation_posreplacepos_replacef.txt'),'w');
mkdir(logDirectory)

%Constants :

psi = mexihat(-10,10,30); %
psi2 = mexihat(-11,11,30); %Mexican Hat Filter
minimallength = 30; % Minimal Length of a box to be considered and convolved with the profile detector (Needs to be adjusted if the mexican filter is extended.
colors=['b' 'g' 'r' 'c' 'm' 'y' 'w'];
fileName = {[]}; % Initiation of the array
clims = [0 255]; % 256 Bits images
posmin = 0.35; %Minimal limit for the center position of the septum
posmax = 0.65; % Maximal limit for the center position of the septum
deltaintens = 15; % Min Intensity differences to be computed to check if a cell is in fact 2 cells (Max intensity profile and min Intensity profile), might need adjustements regarding the optical set-up
minimalintens = 72; % Minimal Intensity, might need adjustements regarding the optical set-up

chansize = channel_size; % Can be given externally in scripts, width of the channel in pixels.

Split1 = 5; %Number of channels in the image.
marque = 1;% Value = 1 to prevent a bad first image of the subset analysis, Otherwise = 2.
valuetoadd = val_to_add; % Can be adjusted if the image intensity is not uniform along the x Axis
threshval = back_val; % Global intensity corrector.
XMax = 0; % 0 or 1, if 0, compute an X_Limit without Cells, if 1, X_Limit = end of the image.
%minim = minimal distance within the contour (pinched areas)


minBound = 1000;  % Maximal enclosed area to consider as single cell : Normal version
minLong = 200; % Maximal Length of the cells  % Normal Version
%minBound = 1500; %Some longer mutant
%minLong = 250; %Some longer mutant

%replacef can be edited to make smaller groups of parallel processed
%images.
for f = (replacef*100)+1:(replacef+1)*100
    k = f;
    
    fileName{f} = dirImage(f).name'; %Extract filenames : The images were always stored : start_21h14_dia_posy_20150101_211504.tif with 21h14 time of the beginning of the exp, dia = filterset, posy = position number, 20150101 Date of the the image acquisition, 211505 time of the image : 21 h 15 m 05 s
    [stringtofilter] = regexp(fileName{f}', '\_', 'split');
    starttime = stringtofilter{2};
    filter2 = stringtofilter{3};
    position = stringtofilter{4};
    date = stringtofilter{5};
    picnumber = stringtofilter{6};
    imagingtime = picnumber;
    picnumber = char(picnumber(1:length(picnumber)-4));
    ImageName = sprintf('start_%s_%s_%s_%s_%s.tif', starttime ,filter2, position, date, picnumber); % Reconstitute the ImageFileName;
    
    BW = imread([loadingDirectory '/' ImageName]); % Read the image
    imagesizey = size(BW,1); % Extract y dimension
    imagesizex = size(BW,2); % Extract x dimension
    imLength = imagesizex; % X length of the image
    ski2 = 0;
    if std2(BW) < 9.5 && marque ~= 1 % Used to prevent segmentation of an out of focus image. To replace it, the previous image is used.
        
        imagetext = nd_texture(BW, highway_mask, 32); % Extract the texture according to the cited paper.
        
        if imagetext(2) < replacetext2 && imagetext(10) < replacetext10
            
            f2 = f-1;
            [stringtofilter2] = regexp(fileName{f2}', '\_', 'split');
            starttime2 = stringtofilter2{2};
            filter3 = stringtofilter2{3};
            position2 = stringtofilter2{4};
            date2 = stringtofilter2{5};
            picnumber2 = stringtofilter2{6};
            imagingtime2 = picnumber2;
            picnumber2 = char(picnumber2(1:length(picnumber2)-4));
            ImageName2 = sprintf('start_%s_%s_%s_%s_%s.tif', starttime2 ,filter3, position2, date2, picnumber2);
            loadfileName = fullfile(savefiledirectory1, sprintf('start_%s_%s_%s_%s_%s_global_variables.mat', starttime2 ,filter3, position2, date2, picnumber2));
            load(loadfileName, 'Split2', 'topsplit2', 'lowsplit2', 'highway_masks2','highway_mask', 'mod_highay_bounds2', 'highway_bounds2', 'VertVals2', 'tempim2', 'deltafac', 'level');
            savefileName = fullfile(savefiledirectory1, sprintf('start_%s_%s_%s_%s_%s_global_variables.mat', starttime ,filter2, position, date, picnumber));
            save(savefileName, 'Split2', 'topsplit2', 'lowsplit2', 'highway_masks2','highway_mask', 'mod_highay_bounds2', 'highway_bounds2', 'VertVals2', 'tempim2', 'deltafac', 'level');fprintf(log_file2, 'Copied results for image %d\n', f);
            fprintf(log_file2, 'copied image %d \n', f);
            for subpart = 1:Split2
                loadsubfileName = fullfile(savefiledirectory1, sprintf('start_%s_%s_%s_%s_%s_part%d_variables.mat', starttime2 ,filter3, position2, date2, picnumber2, subpart));
                load(loadsubfileName, 'newB', 'final_single_cell_indices','working_indices', 'slopevector','newboundarea', 'maxvalues2', 'minvalues2','centroid', 'longueur_profile', 'texture', 'back_ground', 'round_cells', 'highway_indices', 'level2');
                savesubfileName = fullfile(savefiledirectory1, sprintf('start_%s_%s_%s_%s_%s_part%d_variables.mat', starttime ,filter2, position, date, picnumber, subpart));
                save(savesubfileName, 'newB', 'final_single_cell_indices','working_indices', 'slopevector','newboundarea', 'maxvalues2', 'minvalues2','centroid', 'longueur_profile', 'texture', 'back_ground', 'round_cells', 'highway_indices', 'level2');
            end
            continue
        end
    end
    
    
    deltafac = 0.55;
    [Split2, topsplit2, lowsplit2, highway_masks2, mod_highay_bounds2, highway_bounds2, VertVals2, tempim2, highway_mask, highway_bound] = retrievemask_split(BW, deltafac, chansize, XMax); %Split the image into the required number of subchannels. see retrievemask_split. 
    if Split2 ~= Split1 % If the split is higher than 5 change the parameter to resplit
        if Split2 > 5
            deltafac = 0.6;
            [Split2, topsplit2, lowsplit2, highway_masks2, mod_highay_bounds2, highway_bounds2, VertVals2, tempim2, highway_mask, highway_bound] = retrievemask_split(BW, deltafac, chansize, XMax);
        elseif Split2 < Split1 % if the Split is lower, reuse the previous filter.
            Split2 = Split1; 
            topsplit2 = topsplit1;
            lowsplit2 = lowsplit1;
            highway_masks2 = highway_masks1;
            mod_highay_bounds2 = mod_highay_bounds1;
            highway_bounds2 = highway_bounds1;
            VertVals2 = VertVals1;
            tempim2 = tempim1;
            highway_mask = highway_mask1;
            highway_bound = highway_bound1;
            deltafac = 0.55;
        end
    end
    deltaval = double(max(max(BW)) - min(min(BW))); % Compute the variation of intensity (min and max intensity values of the image
    
    
    Indice = find(highway_mask == 0); 
    BW2 = BW;
    BW2(Indice) = 0; %Put the structure areas to 0.
    divnum = 5; %Number of divisions along the x axis, in case the image is not perfectly flat.
    divlength = round((imagesizex-(imagesizex-median(VertVals2)))/divnum); % Length of the subdivision
    if divlength*divnum > imagesizex % Adjustment for the border of the image.
        divlength = floor(imagesizex/divnum);
    end
    highway_mask(:) = highway_mask(:)-1; 
    imagetext = nd_texture(BW, highway_mask, 32);
    
    for i = 1:divnum % Initialize the autothreshold for each subsegment.
        t(i) = 20;
        BW3{i} = BW2(:,(i-1)*divlength+1:(i)*divlength);
        avdown(i) = mean(BW3{i}(BW3{i} <= t(i)));
        avup(i) = mean(BW3{i}(BW3{i} > t(i)));
        putativethresh(i)  = (avdown(i) + avup(i))/2;
    end
    
    for i = 1: divnum % compute the autothreshold for each highway.
        while t(i) < putativethresh(i)
            t(i) = t(i) +1;
            avdown(i)  =  mean(BW3{i}(BW3{i} <= t(i)));
            avup(i) = mean(BW3{i}(BW3{i} > t(i)));
            putativethresh(i) = (avdown(i) + avup(i))/2;
        end
    end
    
    
    for i = 1:divnum
        if imagetext(7) < 53 && imagetext(6) > 40 % If the texture are quite unusual, don't make any adjustements.
            level(i)= (putativethresh(i)+threshval+5)/256;
        else
            level(i)= (putativethresh(i)+threshval)/256-valuetoadd(i)*0.01;% If the texture are bad, adjust the threshold value along the X axis.
        end
    end
    
    for i = 1:divnum
        BW4(:,(i-1)*divlength+1:(i)*divlength) = im2bw(BW3{i},level(i)); % Adjust the image for each segment along X axis.
    end
    BW4(:, i*divlength:imLength) = 0; % Just kept to be possibly imaged.
    BW5 = BW4;
    BW5(Indice) = 0;
    
    
    for subpart = 1:Split2 % Compute the values for each highway.
        
        clear smallImage3;
        
        subimagesizey = size(tempim2{subpart},1);
        subimagesizex = size(tempim2{subpart},2);
        tempmask = highway_masks2{subpart};
        Indicesmall = find( tempmask == 0);
        
        smallImage = tempim2{subpart};
        smallImage(Indicesmall) = 0;
        
        for i = 1:divnum
            t(i) = 20;
            small3{i} = smallImage(:,(i-1)*divlength+1:(i)*divlength);
            avdown(i) = mean(small3{i}(small3{i} <= t(i)));
            avup(i) = mean(small3{i}(small3{i} > t(i)));
            putative(i)  = (avdown(i) + avup(i))/2;
        end
        
        for i = 1: divnum
            while t(i) < putativethresh(i)
                t(i) = t(i) +1;
                avdown(i)  =  mean(small3{i}(small3{i} <= t(i)));
                avup(i) = mean(small3{i}(small3{i} > t(i)));
                putative(i) = (avdown(i) + avup(i))/2;
            end
        end
        deltathresh = (mean(putativethresh)-mean(putative))/3;
        for i = 1:divnum
            if imagetext(7) < 53 && imagetext(6) > 40
                level3(i)= (putativethresh(i)+deltathresh+threshval+5)/256;
            else
                level3(i)= (putativethresh(i)+deltathresh+threshval)/256-valuetoadd(i)*0.01;
            end
        end
        
        
        for i = 1:divnum
            smallImage2{i} = smallImage(:,(i-1)*divlength+1:(i)*divlength);
        end
        for i = 1:divnum
            smallImage3(:,(i-1)*divlength+1:(i)*divlength) = im2bw(smallImage2{i},level3(i));
        end
        
        smallImage3(:,i*divlength:imLength) = 0;
        
        
        
        %Calculating the boudary of the image
        addedval = 0;
        [B,L,N,A] = bwboundaries(smallImage3, 'noholes'); % N, A can be removed to increase computational speed, but cannot be controled for inside contours anymore.
        level2 = level3;
        maximal = 0;
        
        % Look for the biggest contour in each highway. 
        for truc = 1:length(B)
            argh = size(B{truc}, 1);
            
            if argh > maximal
                bound = B{truc};
                if (size(unique(bound(:,1)),1) > 2 && size(unique(bound(:,2)),1) > 2)
                    maximal = argh; iargh = truc;
                end
                
            end
        end
        
        
        bound = B{iargh};
        maxarea = polyarea(bound(:,2), bound(:,1)); % Compute the area of this contour.
        [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1)); % Compute the surrounding rectangle around the contour.
        first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2); %Compute length and width of the rectangle.
        second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
        if first < second
            width = first;
            longueur = second;
        else
            width = second;
            longueur = first;
        end
      
        box = [floor(min(rectx)-3) floor(min(recty)-3) ceil(max(rectx)-min(rectx)+3) ceil(max(recty)-min(recty)+3)];% Extract the box surrounding the rectangle (need it to extract the subimage, as image crops are defined by an horizontal rectangle.
        croped_part = imcrop(BW, box);
        croped_mask =  poly2mask(bound(:,2)-box(1), bound(:,1)-box(2), box(4)+1,box(3)+1);
        text1 =  nd_texture(croped_part, croped_mask, 32);
        
        
        flagA = 0;
        if isempty(find(A)) == 0; % A contours define enclosed contours. if there is one, compute the size of the enclosed contour
            maxAarea = 0;
            for k = 1:size(A,2)
                if find(A(:,k));
                    ins = find(A(:,k));
                    bound = B{ins};
                    aireins = polyarea(bound(:,2), bound(:,1));
                    if aireins > maxAarea
                        maxAarea = aireins;
                    end
                end
                
            end
            if maxAarea > 200
                flagA = 1;
            else
                flagA = 0;
            end
        end

        
        clear convex_check;
        clear boundarea;
        clear hullarea;
        clear trash_indices
        clear area_ratio
        clear back_ground
        back_ground = 0;
        
        
        %% preprocessing to discard small things that can't be check with convhull
        'Processing the trash indices';
        k = 1;
        indices = zeros(size(B,1));
        for i = 1:size(B,1)
            bound = B{i};
            aire = polyarea(bound(:,2),bound(:,1)); % compute area of the contour
            if aire < 80 % If small area = Discarded
                indices(k) = i;
                computed_indices2(i) = 0;
            elseif aire < 170 && aire > 80 % small things that can either be part of a cell or "others"
                
                [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                box = [floor(min(rectx)-3) floor(min(recty)-3) ceil(max(rectx)-min(rectx)+3) ceil(max(recty)-min(recty)+3)];
                croped_part = imcrop(BW, box);
                
                
                croped_mask =  poly2mask(bound(:,2)-box(1), bound(:,1)-box(2), box(4)+1,box(3)+1);
                
                texture(k,:) =  nd_texture(croped_part, croped_mask, 32);
                machinconv = convhull(bound(:,2), bound(:,1));
                
                
                [rectx, recty, area, perimeter] = minboundrect(bound(machinconv,2), bound(machinconv,1));
                
                first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                if first < second
                    width = first;
                    longueur = second;
                else
                    width = second;
                    longueur = first;
                end
                minim = 1000;
                longu=length(bound); % compute the minimal distance between points of the contours (Pinched cells)
                for i = 1:longu
                    for j = round(longu/5):longu-round(longu/5)
                        secondpoint = mod(i+j,longu)+1;
                        distance = sqrt((bound(i,1)-bound(secondpoint,1))^2 + (bound(i,2)-bound(secondpoint,2))^2);
                        
                        if distance < minim
                            minim = distance;
                            indicei = i;
                            indicej = secondpoint;
                        end
                    end
                end
                convaire = polyarea(bound(machinconv,2), bound(machinconv,1));
                triangleaire = longueur*width/2;
                
                
                
                if polyarea(bound(:,2),bound(:,1)) < 170 && texture(k,2) <  0.75 && texture(k,4) < 2 && texture(k,11) < 1
                    indices(k) = i;
                    computed_indices2(i) = 0;
                elseif polyarea(bound(:,2),bound(:,1)) < 170 && triangleaire/convaire > 0.8
                    indices(k) = i;
                    computed_indices2(i) = 0;
                end
                
                
                
                
            end
            k = k+1;
        end
        
        trash_indices = find(indices);
        length(trash_indices);
        
        clear round_cells % in case there are round cells, they can be computed with the area ratio differences, mutant cells investigation)
        round_cells(1) = 0;
        
        clear computed_indices;
        clear computed_indices2;
        clear computed_indices3;
        clear computed_indices4
        clear working_indices;
        clear final_computed_indices
        
        
        computed_indices = 1:size(B,1);
        computed_indices2 = computed_indices;
        
        computed_indices2(trash_indices) = 0;
        
        boundarea = zeros(1,k);
        hullarea = zeros(1,k);
        area_ratio = zeros(1,k);
        
        
        convex_check = B;
        for k = 1:length(computed_indices2)
            if computed_indices2(k) == 0
                convex_check{k} = {0};
                boundarea(k)= 0;
                hullarea(k) = 0;
                area_ratio(k) = 0;
                
            else
                bound=B{computed_indices2(k)};
                convex_check{computed_indices2(k)} = convhull(bound(:,2),bound(:,1));
                boundarea(computed_indices2(k))= polyarea(bound(:,2),bound(:,1));
                hullarea(computed_indices2(k)) = polyarea(bound(convex_check{computed_indices2(k)},2),bound(convex_check{computed_indices2(k)},1));
                area_ratio(computed_indices2(k)) = boundarea(computed_indices2(k))/hullarea(computed_indices2(k));
                clear bound;
            end
        end
        
        
        finalarea_ratio =  area_ratio;
        finalhullarea = hullarea;
        finalboundarea = boundarea;
        
        
        %If any highways were badly discarded, they will end in this
        %category with widely long contours.
        clear highway_indices;
        k = 1;
        indices = zeros(length(computed_indices2),1);
        for i = 1:length(computed_indices2)
            if boundarea(i) > 750
                bound = B{computed_indices2(i)};
                [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                if first < second
                    width = first;
                    longueur = second;
                else
                    width = second;
                    longueur = first;
                end
                if (area_ratio(i) > 0.75 || width < 18) && longueur > 250 && width/longueur < 0.02
                    indices(k) = i;
                    computed_indices2(i) = 0;
                end
            end
            k = k+1;
        end
        highway_indices = find(indices);
        %
        
        
        
        
        %%    'compute the single cell indices'; for each contour, the width, length, area, convhull area texture and profiles are extracted.
        
        clear single_cell_indices;
        clear indices;
        k = 1;
        indices = zeros(length(computed_indices2),1);
        for i = 1:length(computed_indices2)
            if computed_indices2(i) ~= 0
                bound = B{computed_indices2(i)};
                
                %Length and width of the cell
                [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                if first < second
                    width = first;
                    longueur = second;
                else
                    width = second;
                    longueur = first;
                end
                
                %Area
                airetocheck = width/2*longueur;
                machinconv = convhull(bound(:,2), bound(:,1));
                centroid(k,:) = [mean(bound(machinconv,2)) mean(bound(machinconv,1))];
                convhullarea = polyarea(bound(machinconv,2), bound(machinconv,1));
                
                if boundarea(i) < minBound && area_ratio(i) > 0.8 && width < 20 && longueur < minLong && airetocheck / convhullarea < 0.7   %% && centroid(1) > 35 && centroid(1) < 1270 && centroid(2) > 30 && centroid(2) < 935
                    
                    maxirectlength = 0;
                    clear maxirectlengthindex;
                    maxirectwidth = 0;
                    clear maxirectwidthindex;
                    temp1 = zeros(length(rectx)-1,1);
                    for i2 = 1:length(rectx)-1
                        temp1(i2) = sqrt((rectx(i2)-rectx(i2+1))^2 + (recty(i2)-recty(i2+1))^2);
                        if temp1(i2) > maxirectlength
                            maxirectlength = temp1(i2);
                            maxirectlengthindex = i2;
                        end
                    end
                    maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                    maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                     %% Compute the profile
                    topx = max(rectx);
                    lowx = min(rectx);
                    topy = max(recty);
                    lowy = min(recty);
                    turningboxxaxis = [lowx topx topx lowx lowx];
                    turningboxyaxis = [lowy lowy topy topy lowy];
                    rectlength = topx-lowx;
                    rectwidth = topy-lowy;
                    middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                    opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                    [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit]= myprofileline(middle_point, opposite_middle_point);
                    slopevector(k) = slope;
                    longueur_profile(k) = length_profile;
                    Xprofiles{k} = xprofile;
                    Yprofiles{k} = yprofile;
                    test = round(xprofile);
                    test2 = round(yprofile);
                    clear pixelvalue;
                    clear testy;
                    clear testx;
                    
                    for perp = 1:7
                        testy{perp} = round((yprofile+(4-perp)*(-1)*deltaxunit)); %ceil
                        testx{perp} = round((xprofile+(4-perp)*deltayunit));
                        [testx{perp}, testy{perp}] = checkprofile(testx{perp}, testy{perp}, subimagesizex, subimagesizey);
                        for l = 1:length(testx{perp})
                            pixelvalue(perp,l) = tempim2{subpart}(round(testy{perp}(l)), round(testx{perp}(l)));
                        end
                        
                    end
                    
                    %Average the 7 parallel profiles
                    values = mean(pixelvalue(:,1:l));
                    if longueur > minimallength
                        valuestemp = (conv(values,psi2,'valid'));
                        [values2(k,1), values2(k,2)] = max(valuestemp);
                        [values3(k,1), values3(k,2)] = min(valuestemp);
                        
                        values2(k,2) = values2(k,2)/length(valuestemp);
                        values3(k,2) = values3(k,2)/length(valuestemp);
                        values4 = (conv(double(values),double(psi),'valid'));
                        [maxvalues2(k), maxpos(k)] = max(values4);
                        [minvalues2(k), minpos(k)] = min(values4);
                        
                    else
                        values2(k,1)= 0;
                        values2(k,2) = 0;
                        values3(k,1)= 0;
                        values3(k,2) = 0;
                        maxvalues2(k)= 0;
                        maxpos(k) = 0;
                        minvalues2(k)= 0;
                        minpos(k) = 0;
                    end
                    box = [floor(min(rectx)-3) floor(min(recty)-3) ceil(max(rectx)-min(rectx)+3) ceil(max(recty)-min(recty)+3)];
                    croped_part = imcrop(smallImage, box);
                    croped_mask =  poly2mask(bound(:,2)-box(1), bound(:,1)-box(2), box(4)+1,box(3)+1);
                    texture(k,:) =  nd_texture(croped_part, croped_mask, 32);
                    
                    minim = 1000;
                    longu=length(bound);
                    for i = 1:longu
                        for j = round(longu/5):longu-round(longu/5)
                            secondpoint = mod(i+j,longu)+1;
                            distance = sqrt((bound(i,1)-bound(secondpoint,1))^2 + (bound(i,2)-bound(secondpoint,2))^2);
                            
                            if distance < minim
                                minim = distance;
                                indicei = i;
                                indicej = secondpoint;
                            end
                        end
                    end
                    if texture(k,2) <  0.75 && texture(k,4) < 2 && texture(k,11) < 1
                        trash_indices(1+length(trash_indices)) = i;
                    elseif minim < 3 && longueur > 70
                        
                    else
                        indices(k) = i;
                        i;
                    end
                end
            end
            k = k+1;
            
        end
        single_cell_indices = find(indices);
        length(single_cell_indices);
        
        
        %%  compute the indices of things we still have to work on. Those will be treated individually
        computed_indices3 = computed_indices2;
        if isempty(highway_indices) == 0
            computed_indices3(highway_indices) = 0;
        end
        computed_indices3(single_cell_indices) = 0;
        computed_indices3 = find(computed_indices3);
        
        clear final_computed_indices
        clear working_indices
        clear newB
        clear newarea_ratio
        clear newhullarea
        clear newboundarea
        clear final_single_cell_indices
        
        %recursive splitting of one figure, those will be smaller in each
        %iterations
        final_computed_indices = computed_indices3;
        working_indices = computed_indices3;
        inside_indices = working_indices;
        newB = B;
        newarea_ratio = area_ratio;
        newhullarea = hullarea;
        newboundarea = boundarea;
        final_single_cell_indices = single_cell_indices;
        
        split_seg = @split_segments_evolution;
        long = length(working_indices);
        BWOLD = BW;
        IterationNumber = 0;
        stop = 0;
        while  (IterationNumber < 15)
            if isempty(find(working_indices)) == 1
                stop = 1;
                break
            end
            IterationNumber = IterationNumber +1;
            long = length(working_indices);
            
            for lambda = 1:long
                nouvelle_longueur = length(working_indices);
                
                if working_indices(lambda) == 0
                    
                else
                    clear boundary_to_split
                    boundary_to_split = newB{working_indices(lambda)};
                    bound = boundary_to_split;
                    
                    [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                    first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                    second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                    if first < second
                        width = first;
                        longueur = second;
                    else
                        width = second;
                        longueur = first;
                    end
                    minim = 1000;
                    longu=length(bound);
                    for i = 1:longu
                        for j = round(longu/5):longu-round(longu/5)
                            secondpoint = mod(i+j,longu)+1;
                            distance = sqrt((bound(i,1)-bound(secondpoint,1))^2 + (bound(i,2)-bound(secondpoint,2))^2);
                            
                            if distance < minim
                                minim = distance;
                                indicei = i;
                                indicej = secondpoint;
                            end
                        end
                    end
                    
                    box = [floor(min(rectx)-3) floor(min(recty)-3) ceil(max(rectx)-min(rectx)+3) ceil(max(recty)-min(recty)+3)];
                    croped_part = imcrop(tempim2{subpart}, box);
                    croped_mask =  poly2mask(bound(:,2)-box(1), bound(:,1)-box(2), box(4)+1,box(3)+1);
                    texture(working_indices(lambda),:) =  nd_texture(croped_part, croped_mask, 32);
                    aire = polyarea(bound(:,2), bound(:,1));
                    cellperim = length(bound);
                    circularity = 4*pi()*(aire/cellperim^2);
                    if ((width < 22 && minim > 7 && minim < 12) || width < 19 ) && longueur < 200 && aire > 80 %&& centroid(1) > 35 && centroid(1) < 1280 && centroid(2) > 30 && centroid(2) < 935
                        machinconv = convhull(bound(:,2), bound(:,1));
                        centroid(working_indices(lambda),:) = [mean(bound(machinconv,2)) mean(bound(machinconv,1))];
                        maxirectlength = 0;
                        clear maxirectlengthindex;
                        maxirectwidth = 0;
                        clear maxirectwidthindex;
                        temp1 = zeros(length(rectx)-1,1);
                        for i2 = 1:length(rectx)-1
                            temp1(i2) = sqrt((rectx(i2)-rectx(i2+1))^2 + (recty(i2)-recty(i2+1))^2);
                            if temp1(i2) > maxirectlength
                                maxirectlength = temp1(i2);
                                maxirectlengthindex = i2;
                            end
                        end
                        maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                        maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                        
                        middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                        
                        opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                        [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit]= myprofileline(middle_point, opposite_middle_point);
                        slopevector(working_indices(lambda)) = slope;
                        longueur_profile(working_indices(lambda)) = length_profile;
                        Xprofiles{working_indices(lambda)} = xprofile;
                        Yprofiles{working_indices(lambda)} = yprofile;
                        
                        test = round(xprofile);
                        test2 = round(yprofile);
                        clear pixelvalue;
                        clear testy;
                        clear testx;
                        
                        for perp = 1:7
                            testy{perp} = round((yprofile+(4-perp)*(-1)*deltaxunit)); %ceil
                            testx{perp} = round((xprofile+(4-perp)*deltayunit));
                            [testx{perp}, testy{perp}] = checkprofile(testx{perp}, testy{perp}, subimagesizex, subimagesizey);
                            for l = 1:length(testx{perp})
                                pixelvalue(perp,l) = tempim2{subpart}(round(testy{perp}(l)), round(testx{perp}(l)));
                            end
                            
                        end
                        
                        clear values;
                        clear valuestest;
                        clear values5;
                        clear values4;
                        
                        valuestest = median(pixelvalue(:,1:l));
                        values = mean(pixelvalue(:,1:l));
                        %                     values4 = (conv(values,psi2,'valid'));
                        values5 = (conv(double(valuestest), double(psi2), 'valid'));
                        values4 = (conv(double(values),double(psi),'valid'));
                        if length(values)> 10
                            [maxinten(working_indices(lambda)), posmaxinten(working_indices(lambda))] = max(values(5:length(values)-5));
                            posmaxintens = posmaxinten(working_indices(lambda))/length(values);
                            [mininten(working_indices(lambda)), posmininten(working_indices(lambda))] = min(values(5:length(values)-5));
                            posminintens = posmininten(working_indices(lambda))/length(values);
                        else
                            working_indices(lambda) = 0;
                            continue
                        end
                        
                        if length(values) > minimallength
                            [maxvalues2(working_indices(lambda)), maxpos(working_indices(lambda))] = max(values4);
                            [minvalues2(working_indices(lambda)), minpos(working_indices(lambda))] = min(values4);
                            minipos(working_indices(lambda)) = minpos(working_indices(lambda))/length(values4);
                            maxipos(working_indices(lambda)) = maxpos(working_indices(lambda))/length(values4);
                        else
                            maxvalues2(working_indices(lambda)) = 100;
                            maxipos(working_indices(lambda)) = 0.5;
                        end
                        
                        % Various parameters to investigate of cells are
                        % new single cells, discarded contours or still
                        % need refinements.
                        if longueur < 45 || maxvalues2(working_indices(lambda)) > 14 && maxipos(working_indices(lambda)) > posmin && maxipos(working_indices(lambda)) < posmax && minvalues2(working_indices(lambda)) > -22 && minipos(working_indices(lambda)) > posmax && minipos(working_indices(lambda)) < posmin
                            if newboundarea(working_indices(lambda)) < 100
                                working_indices(lambda) = 0;
                            else
                                [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                if first < second
                                    width = first;
                                else
                                    width = second;
                                end
                                if (newarea_ratio(working_indices(lambda)) >0.70 && newboundarea(working_indices(lambda))<1500 && width < 22) || (newboundarea(working_indices(lambda)) < 600&& width < 20) && texture(working_indices(lambda),2) >  0.75 && texture(working_indices(lambda),4) > 2 && texture(working_indices(lambda),11) > 1.1
                                    final_single_cell_indices(length(final_single_cell_indices)+1) = working_indices(lambda);
                                    working_indices(lambda) = 0;
                                elseif texture(working_indices(lambda),2) <  0.75 && texture(working_indices(lambda),4) < 2 && texture(working_indices(lambda),11) < 1.1
                                    trash_indices(1+length(trash_indices)) = working_indices(lambda);
                                    working_indices(lambda) = 0;
                                end
                            end
                            
                        elseif (minvalues2(working_indices(lambda)) < -7 &&  minipos(working_indices(lambda)) >= posmin+0.05 && minipos(working_indices(lambda)) <= posmax-0.05 && minim <= 3.5) || (minvalues2(working_indices(lambda)) < -14 &&  minipos(working_indices(lambda)) > posmin+0.05 && minipos(working_indices(lambda)) < posmax-0.05 && minim <= 7)|| (longueur > 110 && minim < 6) ||  (minvalues2(working_indices(lambda)) < - 28 &&  minim < 6 && maxvalues2(working_indices(lambda)) < 25) || (maxinten(working_indices(lambda))-mininten(working_indices(lambda)) > deltaintens && mininten(working_indices(lambda)) < minimalintens && minim < 8)
                            %Cases that need to be split :
                            [first_path, second_path, minim] = split_seg(boundary_to_split,5);
                            if first_path ~= 0
                                new_path_indice = length(newB)+1;
                                tempnewB = newB;
                                newB{working_indices(lambda)} = first_path;
                                newB{new_path_indice} = second_path;
                                alpha = [working_indices(lambda) new_path_indice];
                                for k = 1:2
                                    bound=newB{alpha(k)};
                                    minim = 1000;
                                    indicei = 0;
                                    indicej = 0;
                                    longu=length(bound);
                                    for i = 1:longu
                                        for j = round(longu/5):longu-round(longu/5)
                                            secondpoint = mod(i+j,longu)+1;
                                            distance = sqrt((bound(i,1)-bound(secondpoint,1))^2 + (bound(i,2)-bound(secondpoint,2))^2);
                                            
                                            if distance < minim
                                                minim = distance;
                                                indicei = i;
                                                indicej = secondpoint;
                                            end
                                        end
                                    end
                                    if polyarea(bound(:,2), bound(:,1)) == 0
                                        if k == 1
                                            working_indices(lambda) = 0;
                                        else
                                            working_indices(nouvelle_longueur+1) = 0;
                                        end
                                    else
                                        
                                        
                                        
                                        
                                        
                                        
                                        [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                        first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                        second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                        if first < second
                                            width = first;
                                            longueur = second;
                                        else
                                            width = second;
                                            longueur = first;
                                        end
                                        
                                        convex_check{alpha(k)} = convhull(bound(:,2),bound(:,1));
                                        newhullarea(alpha(k)) = polyarea(bound(convex_check{alpha(k)},2),bound(convex_check{alpha(k)},1));
                                        newboundarea(alpha(k))= polyarea(bound(:,2),bound(:,1));
                                        newarea_ratio(alpha(k)) = newboundarea(alpha(k))/newhullarea(alpha(k));
                                        machinconv = convhull(bound(:,2), bound(:,1));
                                        centroid(alpha(k),:) = [mean(bound(machinconv ,2)) mean(bound(machinconv ,1))];
                                        
                                        maxirectlength = 0;
                                        
                                        clear maxirectlengthindex;
                                        maxirectwidth = 0;
                                        clear maxirectwidthindex;
                                        temp1 = zeros(length(rectx)-1,1);
                                        for i2 = 1:length(rectx)-1
                                            temp1(i2) = sqrt((rectx(i2)-rectx(i2+1))^2 + (recty(i2)-recty(i2+1))^2);
                                            if temp1(i2) > maxirectlength
                                                maxirectlength = temp1(i2);
                                                maxirectlengthindex = i2;
                                            end
                                        end
                                        maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                                        maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                                        
                                        middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                                        
                                        opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                                        [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit]= myprofileline(middle_point, opposite_middle_point);
                                        slopevector(alpha(k)) = slope;
                                        longueur_profile(alpha(k)) = length_profile;
                                        Xprofiles{alpha(k)} = xprofile;
                                        Yprofiles{alpha(k)} = yprofile;
                                        
                                        
                                        
                                        box = [floor(min(rectx)-3) floor(min(recty)-3) ceil(max(rectx)-min(rectx)+3) ceil(max(recty)-min(recty)+3)];
                                        croped_part = imcrop(tempim2{subpart}, box);
                                        croped_mask =  poly2mask(bound(:,2)-box(1), bound(:,1)-box(2), box(4)+1,box(3)+1);
                                        texture(alpha(k),:) =  nd_texture(croped_part, croped_mask, 32);
                                        if newboundarea(alpha(k)) < 100  || texture(alpha(k),2) <  0.75 && texture(alpha(k),4) < 2 && texture(alpha(k),11) < 1
                                            
                                            if k == 1
                                                working_indices(lambda) = 0;
                                            else
                                                working_indices(length(working_indices)+1) = 0;
                                            end
                                        elseif newboundarea(alpha(k)) > 3000 && newarea_ratio(alpha(k)) > 0.75
                                            if k == 1
                                                working_indices(lambda) = 0;
                                            else
                                                working_indices(length(working_indices)+1) = 0;
                                            end
                                            %                                         highway_indices(length(highway_indices)+1) = alpha(k);
                                        else
                                            [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                            first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                            second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                            if first < second
                                                width = first;
                                            else
                                                width = second;
                                            end
                                            convex_check{alpha(k)} = convhull(bound(:,2),bound(:,1));
                                            newhullarea(alpha(k)) = polyarea(bound(convex_check{alpha(k)},2),bound(convex_check{alpha(k)},1));
                                            newarea_ratio(alpha(k)) = newboundarea(alpha(k))/newhullarea(alpha(k));
                                            machinconv = convhull(bound(:,2), bound(:,1));
                                            centroid(alpha(k),:) = [mean(bound(machinconv ,2)) mean(bound(machinconv ,1))];
                                            
                                            maxirectlength = 0;
                                            
                                            clear maxirectlengthindex;
                                            maxirectwidth = 0;
                                            clear maxirectwidthindex;
                                            temp1 = zeros(length(rectx)-1,1);
                                            for i2 = 1:length(rectx)-1
                                                temp1(i2) = sqrt((rectx(i2)-rectx(i2+1))^2 + (recty(i2)-recty(i2+1))^2);
                                                if temp1(i2) > maxirectlength
                                                    maxirectlength = temp1(i2);
                                                    maxirectlengthindex = i2;
                                                end
                                            end
                                            maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                                            maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                                            
                                            middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                                            
                                            opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                                            [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit]= myprofileline(middle_point, opposite_middle_point);
                                            slopevector(alpha(k)) = slope;
                                            longueur_profile(alpha(k)) = length_profile;
                                            Xprofiles{alpha(k)} = xprofile;
                                            Yprofiles{alpha(k)} = yprofile;
                                            
                                            if (newarea_ratio(alpha(k)) >0.84 && newboundarea(alpha(k))<1500 && width < 20 && minim > 8) || (newboundarea(alpha(k)) < 350 && width < 20)
                                                final_single_cell_indices(length(final_single_cell_indices)+1) = alpha(k);
                                                if k == 1
                                                    working_indices(lambda) = 0;
                                                else
                                                    working_indices(nouvelle_longueur+1) = 0;
                                                end
                                            else
                                                if k == 1
                                                    working_indices(lambda)=alpha(k);
                                                else
                                                    working_indices(nouvelle_longueur+1) = alpha(k);
                                                end
                                            end
                                        end
                                    end
                                end
                            end
                            
                        elseif  maxvalues2(working_indices(lambda)) >28 && maxipos(working_indices(lambda)) > posmin && maxipos(working_indices(lambda)) < posmax %
                            if newboundarea(working_indices(lambda)) < 100
                                working_indices(lambda) = 0;
                            else
                                [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                if first < second
                                    width = first;
                                else
                                    width = second;
                                end
                                if (newarea_ratio(working_indices(lambda)) >0.65 && newboundarea(working_indices(lambda))<1500 && width < 22) || (newboundarea(working_indices(lambda)) < 600&& width < 20)
                                    final_single_cell_indices(length(final_single_cell_indices)+1) = working_indices(lambda);
                                    working_indices(lambda) = 0;
                                end
                            end
                            
                        elseif (maxvalues2(working_indices(lambda)) < 17 && (minvalues2(working_indices(lambda)) > -15 || (minvalues2(working_indices(lambda)) > -20 && (minipos(working_indices(lambda)) < posmin-0.075 || minipos(working_indices(lambda)) > posmax+0.075))) && (longueur < 110 || (longueur < 140 && (newarea_ratio(working_indices(lambda)) >0.75))))
                            if newboundarea(working_indices(lambda)) < 100
                                working_indices(lambda) = 0;
                            else
                                if (newarea_ratio(working_indices(lambda)) >0.67 && newboundarea(working_indices(lambda))<1500 && width < 22) || (newboundarea(working_indices(lambda)) < 600&& width < 20)
                                    final_single_cell_indices(length(final_single_cell_indices)+1) = working_indices(lambda);
                                    working_indices(lambda) = 0;
                                end
                            end
                            
                        elseif (maxvalues2(working_indices(lambda)) >10 && minvalues2(working_indices(lambda)) < -10) && (maxipos(working_indices(lambda)) < posmin  || maxipos(working_indices(lambda)) > posmax) && (minipos(working_indices(lambda)) < posmin || minipos(working_indices(lambda)) > posmax)
                            
                            
                            if newboundarea(working_indices(lambda)) < 100
                                working_indices(lambda) = 0;
                            else
                                if (newarea_ratio(working_indices(lambda)) >0.67 && newboundarea(working_indices(lambda))<1500 && width < 22) || (newboundarea(working_indices(lambda)) < 600&& width < 20)
                                    final_single_cell_indices(length(final_single_cell_indices)+1) = working_indices(lambda);
                                    working_indices(lambda) = 0;
                                end
                            end
                            
                            
                        elseif abs(abs(maxvalues2(working_indices(lambda)))- abs(minvalues2(working_indices(lambda)))) <6 &&  maxvalues2(working_indices(lambda))> 12 && (maxipos(working_indices(lambda)) > posmin  && maxipos(working_indices(lambda)) < posmax)
                            if newboundarea(working_indices(lambda)) < 100
                                working_indices(lambda) = 0;
                            else
                                if (newarea_ratio(working_indices(lambda)) >0.67 && newboundarea(working_indices(lambda))<1500 && width < 22) || (newboundarea(working_indices(lambda)) < 600&& width < 20)
                                    final_single_cell_indices(length(final_single_cell_indices)+1) = working_indices(lambda);
                                    working_indices(lambda) = 0;
                                end
                            end
                            
                        elseif longueur < 55 && maxvalues2(working_indices(lambda)) < 15 && minvalues2(working_indices(lambda)) > -15 && (maxipos(working_indices(lambda)) < posmin  || maxipos(working_indices(lambda)) > posmax) && (minipos(working_indices(lambda)) < posmin || minipos(working_indices(lambda)) > posmax)
                            if newboundarea(working_indices(lambda)) < 100
                                working_indices(lambda) = 0;
                            else
                                if (newarea_ratio(working_indices(lambda)) >0.67 && newboundarea(working_indices(lambda))<1500 && width < 22) || (newboundarea(working_indices(lambda)) < 600&& width < 20)
                                    final_single_cell_indices(length(final_single_cell_indices)+1) = working_indices(lambda);
                                    working_indices(lambda) = 0;
                                end
                            end
                            
                            
                        end
                    elseif aire < 80
                        working_indices(lambda) = 0;
                    elseif texture(working_indices(lambda) ,2) <  0.85 && texture(working_indices(lambda),4) < 3.1 && texture(working_indices(lambda),11) < 1 && aire > 1000 || texture(working_indices(lambda) ,2) <  0.85 && texture(working_indices(lambda),4) < 2.5 && texture(working_indices(lambda),11) < 1 %||   minim > 20  %%&& texture(working_indices(lambda), 7) > 28 && aire > 1000 && IterationNumber > 5 texture(working_indices(lambda), 7) > 40 && IterationNumber > 5 ||
                        back_ground(working_indices(lambda)) = working_indices(lambda);
                        working_indices(lambda) = 0;
                    elseif circularity > 0.9
                        round_cells(length(round_cells)+1) = working_indices(lambda);
                        working_indices(lambda) = 0;
                    else
                        
                        clear temp1
                        maxirectlength = 0;
                        clear maxirectlengthindex;
                        maxirectwidth = 0;
                        clear maxirectwidthindex;
                        temp1 = zeros(length(rectx)-1,1);
                        for i2 = 1:length(rectx)-1
                            temp1(i2) = sqrt((rectx(i2)-rectx(i2+1))^2 + (recty(i2)-recty(i2+1))^2);
                            if temp1(i2) > maxirectlength
                                maxirectlength = temp1(i2);
                                maxirectlengthindex = i2;
                            end
                        end
                        maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                        maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                        topx = max(rectx);
                        lowx = min(rectx);
                        topy = max(recty);
                        lowy = min(recty);
                        turningboxxaxis = [lowx topx topx lowx lowx];
                        turningboxyaxis = [lowy lowy topy topy lowy];
                        rectlength = topx-lowx;
                        rectwidth = topy-lowy;
                        middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                        opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                        
                        
                        [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit]= myprofileline(middle_point, opposite_middle_point);
                        slopevector(working_indices(lambda)) = slope;
                        longueur_profile(working_indices(lambda)) = length_profile;
                        Xprofiles{working_indices(lambda)} = xprofile;
                        Yprofiles{working_indices(lambda)} = yprofile;
                        [first_path, second_path, minim] = split_seg(boundary_to_split,5);
                        if first_path ~= 0
                            new_path_indice = length(newB)+1;
                            tempnewB = newB;
                            newB{working_indices(lambda)} = first_path;
                            newB{new_path_indice} = second_path;
                            alpha = [working_indices(lambda) new_path_indice];
                            for k = 1:2
                                bound=newB{alpha(k)};
                                minim = 1000;
                                indicei = 0;
                                indicej = 0;
                                longu=length(bound);
                                for i = 1:longu
                                    for j = round(longu/5):longu-round(longu/5)
                                        secondpoint = mod(i+j,longu)+1;
                                        distance = sqrt((bound(i,1)-bound(secondpoint,1))^2 + (bound(i,2)-bound(secondpoint,2))^2);
                                        
                                        if distance < minim
                                            minim = distance;
                                            indicei = i;
                                            indicej = secondpoint;
                                        end
                                    end
                                end
                                if polyarea(bound(:,2), bound(:,1)) == 0
                                    if k == 1
                                        working_indices(lambda) = 0;
                                    else
                                        working_indices(nouvelle_longueur+1) = 0;
                                    end
                                else
                                    convex_check{alpha(k)} = convhull(bound(:,2),bound(:,1));
                                    newhullarea(alpha(k)) = polyarea(bound(convex_check{alpha(k)},2),bound(convex_check{alpha(k)},1));
                                    newboundarea(alpha(k))= polyarea(bound(:,2),bound(:,1));
                                    newarea_ratio(alpha(k)) = newboundarea(alpha(k))/newhullarea(alpha(k));
                                    machinconv = convhull(bound(:,2), bound(:,1));
                                    centroid(alpha(k),:) = [mean(bound(machinconv,2)) mean(bound(machinconv,1))];
                                    
                                    box = [floor(min(rectx)-3) floor(min(recty)-3) ceil(max(rectx)-min(rectx)+3) ceil(max(recty)-min(recty)+3)];
                                    croped_part = imcrop(tempim2{subpart}, box);
                                    croped_mask =  poly2mask(bound(:,2)-box(1), bound(:,1)-box(2), box(4)+1,box(3)+1);
                                    texture(alpha(k),:) =  nd_texture(croped_part, croped_mask, 32);
                                    if k == 2
                                        working_indices(nouvelle_longueur+1) = alpha(k);
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
        long = length(working_indices);
        
        for lambda = 1:long
            if working_indices(lambda) == 0
            else
                if texture(working_indices(lambda),2) < 1.8 && texture(working_indices(lambda), 10) < 1.2
                    back_ground(working_indices(lambda)) = working_indices(lambda);
                    working_indices(lambda) = 0;
                end
            end
        end
        
        
        
       %Save the extracted datas.
       
        savefileName = fullfile(savefiledirectory1, sprintf('start_%s_%s_%s_%s_%s_part%d_variables.mat', starttime ,filter2, position, date, picnumber, subpart));
        % %Save the local variables
        tempimage = tempim2{subpart};
        subhighway_masks = highway_masks2{subpart};
        modsubhighway_masks = mod_highay_bounds2{subpart};
        highway_boundaries = highway_bounds2{subpart};
        topsplitval = topsplit2(subpart);
        lowsplitval = lowsplit2(subpart);
        save(savefileName,'newB', 'final_single_cell_indices','working_indices', 'slopevector','newboundarea', 'maxvalues2', 'minvalues2','centroid', 'longueur_profile', 'texture', 'back_ground', 'round_cells', 'highway_indices', 'level2');
        
    end
    
    
    marque = 2;
    savefileName = fullfile(savefiledirectory1, sprintf('start_%s_%s_%s_%s_%s_global_variables.mat', starttime ,filter2, position, date, picnumber));
    save(savefileName, 'Split2', 'topsplit2', 'lowsplit2', 'highway_masks2','highway_mask', 'mod_highay_bounds2', 'highway_bounds2', 'VertVals2', 'tempim2', 'deltafac', 'level');
end

fprintf(log_file2, 'threshval = %d \n', threshval);
fprintf(log_file2, 'deltaintens = %d \n', deltaintens);
fprintf(log_file2, 'valuetoadd = %d \n', valuetoadd);

fclose(log_file2);

