% %A script in order to refine the segmentation
%The idea is that we do the segmentation on the whole image and when it is
%done we come back to the part that were not well segmented. In order to
%check those we will open the segmented file and if there is anything to
%solve we will do it with this script.

mainDirectory = '/'; % Main Directory in which subsequent steps will be saved
dirImage = dir(fullfile(mainDirectory,'*.tif')); % List Images in the directory
loadingDirectory = fullfile(mainDirectory, '');
loadingDirectory2 = fullfile(mainDirectory, 'seg_results');

savefiledirectory1 = fullfile(mainDirectory,'reseg_results');
mkdir(savefiledirectory);


se2 = strel('disk',3,4);
minimallength = 30;
fileName = {[]};
clims = [0 255];
% replacef = 1;
psi2 = mexihat(-11,11,30);
psi = mexihat(-10,10,30);
chansize = channel_size;

%Individual segmentation. IF a contour cannot be resolved, we try to
%segment it individually and we put those contour back. Efficient if 2
%cells were attached together on a long stretch. The same process is used
%as previously. Cells are then sorted in individual cells or discarded in
%case it was impossible to split them. The processes are the same as the
%segmentation files except that we only segmentat within the previously
%analysed contour.

for f = replacef*1000+1:(replacef+1)*1000;
    f
    fileName{f} = dirImage(f).name';
    [stringtofilter] = regexp(fileName{f}', '\_', 'split');
    starttime = stringtofilter{2};
    fluofilter = stringtofilter{3};
    position = stringtofilter{4};
    date = stringtofilter{5};
    picnumber = stringtofilter{6};
    imagingtime = picnumber;
    picnumber = char(picnumber(1:length(picnumber)-4));
    ImageName = sprintf('start_%s_%s_%s_%s_%s.tif', starttime ,fluofilter , position, date, picnumber);
    
    BW = imread([loadingDirectory '/' ImageName]);
    loadFileName = fullfile(loadingDirectory2, sprintf('start_%s_%s_%s_%s_%s_global_variables.mat',starttime ,fluofilter , position, date, picnumber)); %start_%sh%s_%s_variables.mat', timeh,timem,picnumber));
    
    
    if exist(loadFileName, 'file') == 2
        load(loadFileName)
        
        
        imagesizey = size(BW,1);
        imagesizex = size(BW,2);
        imLength = imagesizex;
        if exist('highway_mask', 'var') ~= 1
            deltafac =  0.55;
            [Split2, topsplit2, lowsplit2, highway_masks2, mod_highay_bounds2, highway_bounds2, VertVals2, tempim2,  highway_mask, highway_bound] = retrievemask_split(BW, deltafac, chansize);
            if Split2 > 5
                deltafac = 0.6;
                [Split2, topsplit2, lowsplit2, highway_masks2, mod_highay_bounds2, highway_bounds2, VertVals2, tempim2,  highway_mask, highway_bound] = retrievemask_split(BW, deltafac, chansize);
            end
            highway_mask(:) = highway_mask(:)-1;
        end
        highway_mask(:) = highway_mask(:)-1;
        Indice = find(highway_mask == 0);
        highway_mask(:) = highway_mask(:)-1;
        imagetext = nd_texture(BW, highway_mask, 32);
        BW2 = BW;
        BW2(Indice) = 0;
        divnum = 20;
        divlength = round((imagesizex-(imagesizex-median(VertVals2)))/divnum);
        if divlength*divnum > imagesizex
            divlength = floor(imagesizex/divnum);
        end
        
        t = zeros(1,divnum);
        BW3 = {[]};
        avdown = zeros(1,divnum);
        avup = zeros(1,divnum);
        putativethresh = zeros(1,divnum);
        for i = 1:divnum
            t(i) = 20;
            BW3{i} = BW2(:,(i-1)*divlength+1:(i)*divlength);
            avdown(i) = mean(BW3{i}(BW3{i} <= t(i)));
            avup(i) = mean(BW3{i}(BW3{i} > t(i)));
            putativethresh(i)  = (avdown(i) + avup(i))/2;
        end
        
        for i = 1: divnum
            while t(i) < putativethresh(i)
                t(i) = t(i) +1;
                avdown(i)  =  mean(BW3{i}(BW3{i} <= t(i)));
                avup(i) = mean(BW3{i}(BW3{i} > t(i)));
                putativethresh(i) = (avdown(i) + avup(i))/2;
            end
        end

        
        
        for subpart = 1:5
            loadsubFileName = fullfile(loadingDirectory2, sprintf('start_%s_%s_%s_%s_%s_part%d_variables.mat',starttime ,fluofilter , position, date, picnumber, subpart)); %start_%sh%s_%s_variables.mat', timeh,timem,picnumber));
            if exist(loadsubFileName, 'file') == 2
                load(loadsubFileName)
                smallImage = tempim2{subpart};
                
                if isempty(find(working_indices))
                elseif length(final_single_cell_indices) < 75 && f > 1
                    f2 = f-1;
                    fileName2{f2} = dirImage(f2).name';
                    [stringtofilter2] = regexp(fileName2{f2}', '\_', 'split');
                    starttime2 = stringtofilter2{2}; %sscanf(fileName{f},'start_%2dh%*.tif');
                    filter2 = stringtofilter2{3};
                    position2 = stringtofilter2{4};
                    date2 = stringtofilter2{5};
                    picnumber2 = stringtofilter2{6};
                    imagingtime2 = picnumber2;
                    picnumber2 = char(picnumber2(1:length(picnumber2)-4));
                    loadFileName2 = fullfile(loadingDirectory2, sprintf('start_%s_%s_%s_%s_%s_part%d_variables.mat',starttime2 ,filter2, position2, date2, picnumber2, subpart)); %start_%sh%s_%s_variables.mat', timeh,timem,picnumber));
                    load(loadFileName2);
                else
%                     'hi'
                    clear smallImage3;
                    
                    if exist('level2', 'var') == 1
                        level = level2;
                    end
                    level(:) = level(:)+2/256;
                    specLevel = level;
                    subimagesizey = size(tempim2{subpart},1);
                    subimagesizex = size(tempim2{subpart},2);
                    tempmask = highway_masks2{subpart};
                    
                    Indicesmall = find( tempmask == 0);
                    
                    smallImage(Indicesmall) = 0;
                    
                    for i = 1:divnum
                        smallImage2{i} = smallImage(:,(i-1)*divlength+1:(i)*divlength);
                    end
                    for i = 1:divnum
                        smallImage3(:,(i-1)*divlength+1:(i)*divlength) = im2bw(smallImage2{i},level(i));
                    end
                    smallImage3(:,i*divlength:imLength) = 0;
                    
                    
                    
                    clear croped_part;
                    clear indice;
                    clear box;
                    
                    fsci = final_single_cell_indices;
                    compt = 1;
                    clear croped_part
                    clear croped_mask
                    clear box
                    clear indice;
                    for lambda = 1:length(working_indices)
                        if working_indices(lambda) == 0
                        else
                            
                            bound = newB{working_indices(lambda)};
                            centroid5 = [mean(bound(:,2)) mean(bound(:,1))];
                            if texture(working_indices(lambda), 2) < 0.75 && texture(working_indices(lambda), 4) < 2 && texture(working_indices(lambda), 11) < 1 && texture(working_indices(lambda), 13) > 0.75
                                working_indices(lambda) = 0;
                            else
                                [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                
                                for l = 1:size(rectx)
                                    if rectx(l) > subimagesizex
                                        rectx(l) = subimagesizex;
                                    elseif rectx(l) <= 3
                                        rectx(l)=4;
                                    end
                                    if recty(l) > subimagesizey
                                        recty(l) = subimagesizey;
                                    elseif recty(l) <= 3
                                        recty(l)=4;
                                    end
                                end
                                
                                if area > 50
                                    polyarea(bound(:,2), bound(:,1));
                                    if polyarea(bound(:,2), bound(:,1)) > 100
                                        box{compt} = [floor(min(rectx)-3) floor(min(recty)-3) ceil(max(rectx)-min(rectx)+3) ceil(max(recty)-min(recty)+3)];
                                        croped_part{compt} = imcrop(tempim2{subpart}, box{compt});
                                        croped_thresh{compt} = imcrop(smallImage3, box{compt});
                                        indice(compt) = working_indices(lambda);
                                        croped_mask{compt} =  poly2mask(bound(:,2)-box{compt}(1), bound(:,1)-box{compt}(2), box{compt}(4)+1,box{compt}(3)+1);
                                        if size(croped_mask{compt},1) ~= size(croped_part{compt},1) && size(croped_mask{compt},2) == size(croped_part{compt},2)
                                            croped_thresh{compt}(size(croped_part{compt},1)+1:size(croped_mask{compt},1),:) = 1;
                                            croped_part{compt}(size(croped_part{compt},1)+1:size(croped_mask{compt},1),:) = 1;
                                        elseif size(croped_mask{compt},1) == size(croped_part{compt},1) && size(croped_mask{compt},2) ~= size(croped_part{compt},2)
                                            croped_thresh{compt}(:,size(croped_part{compt},2)+1:size(croped_mask{compt},2)) = 1;
                                            croped_part{compt}(:,size(croped_part{compt},2)+1:size(croped_mask{compt},2)) = 1;
                                        elseif size(croped_mask{compt},1) ~= size(croped_part{compt},1) && size(croped_mask{compt},2) ~= size(croped_part{compt},2)
                                            croped_thresh{compt}(size(croped_part{compt},1)+1:size(croped_mask{compt},1),1:size(croped_part{compt},2)) = 1;
                                            croped_part{compt}(size(croped_part{compt},1)+1:size(croped_mask{compt},1),1:size(croped_part{compt},2)) = 1;
                                            croped_thresh{compt}(1:size(croped_part{compt},1),size(croped_part{compt},2)+1:size(croped_mask{compt},2)) = 1;
                                            croped_part{compt}(1:size(croped_part{compt},1),size(croped_part{compt},2)+1:size(croped_mask{compt},2)) = 1;
                                            %                                     '3'
                                        end
                                        compt = compt + 1;
                                    end
                                end
                            end
                            %                             end
                        end
                    end
                    if compt == 1
                    else
                        fsci_leng = length(fsci);
                        valeur_max = max(fsci);
                        newBsize = length(newB);
                        newBres = newB;
                        newfsci = fsci;
                        slopevector2 = slopevector;
                        centroid2 = centroid;
                        newboundarea2 = newboundarea;
                        compt2 = 0;
                        compteurfirst = 0;
                        for p = 1:length(croped_part)
                            clear centroidref;
                            clear textref;
                            clear to_work;
                            clear tresh
                            clear Indice
                            tresh = croped_thresh{p};
                            Indice = find(croped_mask{p} == 0);
                            tresh(Indice) = 0;
                            [smallB,smallL,smallN,smallA] = bwboundaries(tresh, 'noholes');

                            k = 1;
                            indices = zeros(size(smallB,1),1);
                            if size(smallB,1) == 1
                                bound = smallB{1};
                                te = unique(bound);
                                test2a = unique(bound(:,1));
                                test2b = unique(bound(:,2));
                                if te == 1 
                                    continue
                                elseif numel(test2a) == 1 || numel(test2b) == 1
                                    continue
                                end
                                [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                if first < second
                                    leng = second;
                                    width = first;
                                else
                                    leng = first;
                                    width = second;
                                end
                                if width > 30
                                    level = specLevel;
                                    level(:) = level(:)+4/256;
                                    clear smallImage3;
                                    for i = 1:divnum
                                        smallImage3(:,(i-1)*divlength+1:(i)*divlength) = im2bw(smallImage2{i},level(i));
                                    end
                                    smallImage3(:,i*divlength:imLength) = 0;
                                    croped_thresh{p} = imcrop(smallImage3, box{p});
                                    
                                    if size(croped_mask{p},1) ~= size(croped_part{p},1) && size(croped_mask{p},2) == size(croped_part{p},2)
                                        croped_thresh{p}(size(croped_part{p},1)+1:size(croped_mask{p},1),:) = 1;
                                        croped_part{p}(size(croped_part{p},1)+1:size(croped_mask{p},1),:) = 1;
                                    elseif size(croped_mask{p},1) == size(croped_part{p},1) && size(croped_mask{p},2) ~= size(croped_part{p},2)
                                        croped_thresh{p}(:,size(croped_part{p},2)+1:size(croped_mask{p},2)) = 1;
                                        croped_part{p}(:,size(croped_part{p},2)+1:size(croped_mask{p},2)) = 1;
                                    elseif size(croped_mask{p},1) ~= size(croped_part{p},1) && size(croped_mask{p},2) ~= size(croped_part{p},2)
                                        croped_thresh{compt}(size(croped_part{compt},1)+1:size(croped_mask{compt},1),1:size(croped_part{compt},2)) = 1;
                                        croped_part{compt}(size(croped_part{compt},1)+1:size(croped_mask{compt},1),1:size(croped_part{compt},2)) = 1;
                                        croped_thresh{compt}(1:size(croped_part{compt},1),size(croped_part{compt},2)+1:size(croped_mask{compt},2)) = 1;
                                        croped_part{compt}(1:size(croped_part{compt},1),size(croped_part{compt},2)+1:size(croped_mask{compt},2)) = 1;
                                            %                                     '3'
                                        end
                                    tresh = croped_thresh{p};
                                    Indice = find(croped_mask{p} == 0);
                                    tresh(Indice) = 0;
                                    [smallB,smallL,smallN,smallA] = bwboundaries(tresh, 'noholes');
                                    indices = zeros(size(smallB,1),1);
                                end
                            end
                            for i = 1:size(smallB,1)
                                bound = smallB{i};
                                if polyarea(bound(:,2),bound(:,1)) < 50
                                    indices(k) = i;
                                    i;
                                end
                                k = k+1;
                            end
                            trash_indices = find(indices);
                            length(trash_indices);
                            
                            clear computed_indices;
                            clear computed_indices2;
                            
                            computed_indices = 1:size(smallB,1);
                            computed_indices2 = computed_indices;
                            computed_indices2(trash_indices) = 0;
                            
                            smallB2 = smallB;
                            longueurind2 = length(computed_indices2);
                            to_work = computed_indices2;
                            total = 0;
                            while total < 5
                                total = total + 1;
                                if isempty(find(to_work)) == 1
                                    stop = 1;
                                    break
                                end
                                longueurind2 = length(to_work);
                                for nm = 1:longueurind2
                                    if to_work(nm) ~= 0
                                        flaginou = 0;
                                        flagi = 0;
                                        bound = smallB2{computed_indices2(nm)};
                                        [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                        first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                        second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                        
                                        convexhull = convhull(bound(:,2),bound(:,1));
                                        hullarea = polyarea(bound(convexhull,2),bound(convexhull,1));
                                        boundedarea = polyarea(bound(:,2),bound(:,1));
                                        boundarearatio = boundedarea/hullarea;
                                        
                                        if first < second
                                            leng = second;
                                            width = first;
                                        else
                                            leng = first;
                                            width = second;
                                        end
                                        
                                        if width < 7
                                            to_work(nm) = 0;
                                            computed_indices2(nm) = 0;
                                            centroid5(nm,:) = [0 0];
                                            textref(nm,:) = [0 0 0 0 0 0 0 0 0 0 0 0 0];
                                            flago = 0;
                                            
                                        elseif width > 20 || (boundarearatio < 0.65 && leng > 70)
                                            flago = 1;
                                            boundary_to_split = bound;
                                            [first_path, second_path, minim] = split_segments_evolution(boundary_to_split, 3.5);
                                            %                                     [first_path2, second_path2, minim2] = split_segments_evolution(boundary_to_split);
                                            
                                            if first_path ~= 0
                                                if length(unique(second_path(:,2))) > 1 && length(unique(second_path(:,1))) > 1 && length(unique(first_path(:,2))) > 1 && length(unique(first_path(:,1))) > 1 && polyarea(second_path(:,2), second_path(:,1)) > 0 && polyarea(first_path(:,2), first_path(:,1)) > 0
                                                    smallB2{nm} = first_path;
                                                    new_indice = length(smallB2)+1;
                                                    smallB2{new_indice} = second_path;
                                                    to_work(new_indice) = length(to_work)+1;
                                                    computed_indices2(new_indice) = length(computed_indices2)+1;
                                                    %                                                     figure();
                                                    %                                                     hold on;
                                                    %                                                     plot(first_path(:,2), -first_path(:,1), '-r')
                                                    %                                                     plot(second_path(:,2), -second_path(:,1), '-g')
                                                    centroid5(nm,:) = [mean(first_path(:,2)+box{p}(1)) mean(first_path(:,1)+box{p}(2))];
                                                    centroid5(new_indice,:) = [mean(second_path(:,2)+box{p}(1)) mean(second_path(:,1)+box{p}(2))];
                                                    imtoplotnm = poly2mask(first_path(:,2),first_path(:,1), box{p}(4)+1, box{p}(3)+1);
                                                    textref(nm,:) =  nd_texture(croped_part{p}, imtoplotnm, 32);
                                                    imtoplotni = poly2mask(second_path(:,2),second_path(:,1), box{p}(4)+1, box{p}(3)+1);
                                                    textref(new_indice,:) =  nd_texture(croped_part{p}, imtoplotni, 32);
                                                    
                                                    
                                                    
                                                    alpha = [nm new_indice];
                                                    
                                                    for k = 1:2
                                                        bound=smallB2{alpha(k)};
                                                        minim = 1000;
                                                        indicei = 0;
                                                        indicej = 0;
                                                        longu=length(bound);
                                                        for i = 1:longu
                                                            for j = round(longu/3.5):longu-round(longu/3.5)
                                                                secondpoint = mod(i+j,longu)+1;
                                                                distance = sqrt((bound(i,1)-bound(secondpoint,1))^2 + (bound(i,2)-bound(secondpoint,2))^2);
                                                                
                                                                if distance < minim
                                                                    minim = distance;
                                                                    indicei = i;
                                                                    indicej = secondpoint;
                                                                end
                                                            end
                                                        end
                                                        convcheck{alpha(k)} = convhull(bound(:,2),bound(:,1));
                                                        newhullcheck(alpha(k)) = polyarea(bound(convcheck{alpha(k)},2),bound(convcheck{alpha(k)},1));
                                                        newboundareacheck(alpha(k))= polyarea(bound(:,2),bound(:,1));
                                                        newarearatiocheck(alpha(k)) = newboundareacheck(alpha(k))/newhullcheck(alpha(k));
                                                        
                                                        
                                                        if newboundareacheck(alpha(k)) < 100
                                                            to_work(alpha(k)) = 0;
                                                            computed_indices2(alpha(k)) = 0;
                                                        elseif newboundareacheck(alpha(k)) > 3000 && newarearatiocheck(alpha(k)) > 0.75 && width > 17.5
                                                            to_work(alpha(k)) = 0;
                                                            computed_indices2(alpha(k)) = 0;
                                                        else
                                                            [rectx, recty, area, perimeter] =  minboundrect(bound(:,2), bound(:,1));
                                                            first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                                            second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                                            if first < second
                                                                width = first;
                                                            else
                                                                width = second;
                                                            end
                                                            if (newarearatiocheck(alpha(k)) >0.65 && newboundareacheck(alpha(k))<1500 && width < 20 ) || (newboundareacheck(alpha(k)) < 500)
                                                                to_work(alpha(k)) = 0;
                                                            else
                                                                to_work(alpha(k)) = alpha(k);
                                                            end
                                                        end
                                                    end
                                                else
                                                    if minim > 15 && boundarearatio > 0.9
                                                        computed_indices2(nm) = 0;
                                                        to_work(nm) = 0;
                                                    end
                                                end
                                                
                                            else
                                                if minim > 15 && boundarearatio > 0.9
                                                    computed_indices2(nm) = 0;
                                                    to_work(nm) = 0;
                                                end
                                                
                                            end
                                        else
                                            if (boundarearatio > 0.65 && boundedarea <1500 )|| boundedarea < 500
                                                to_work(nm) = 0;
                                            else
                                                to_work(nm) = nm;
                                            end
                                        end
                                    end
                                end
                                
                            end
                            
                            
                            
                            
                            for allo = 1:length(to_work)
                                if to_work(allo)~= 0
                                    computed_indices2(allo) = 0;
                                end
                            end

                            for alphonse = 1:length(computed_indices2)
                                if computed_indices2(alphonse) ~= 0
                                    bound = smallB2{alphonse};
                                    centroid5(alphonse,:) = [mean(bound(:,2)+box{p}(1)) mean(bound(:,1)+box{p}(2))];
                                    imtoplotnm = poly2mask(bound(:,2),bound(:,1), box{p}(4)+1, box{p}(3)+1);
                                    textref(alphonse,:) =  nd_texture(croped_part{p}, imtoplotnm, 32);
                                    
                                    
                                end
                            end
                            
                            
                            computed_indices3 = computed_indices2;
                            slopevec = zeros(1,length(computed_indices2));
                            for k = 1:length(fsci)
                                for l = 1:length(computed_indices2)
                                    if computed_indices2(l)~= 0
                                        
                                        if sqrt((centroid(fsci(k),1)-centroid5(computed_indices2(l),1))^2 + (centroid(fsci(k),2)-centroid5(computed_indices2(l),2))^2)<50
                                            clear boundary1;
                                            clear boundary2;
                                            boundary1 = newB{fsci(k)};
                                            tempbound = smallB2{computed_indices2(l)};
                                            boundary2(:,1)= tempbound(:,1)+box{p}(2);
                                            boundary2(:,2)= tempbound(:,2)+box{p}(1);
                                            
                                            
                                            [x1,y1] = poly2cw(boundary1(:,2), boundary1(:,1));
                                            [x2,y2] = poly2cw(boundary2(:,2), boundary2(:,1));
                                            [xb, yb] = polybool('intersection', x1, y1, x2, y2);
                                            %                                     xb
                                            test = find(isnan(xb));
                                            if test > 1
                                                while test > 1
                                                    xprov = xb;
                                                    yprov = yb;
                                                    xb = [xprov(1:test-1); xprov(test+1:length(xprov))];
                                                    yb = [yprov(1:test-1); yprov(test+1:length(yprov))];
                                                    test = find(isnan(xb));
                                                end
                                            end
                                            
                                            
                                            
                                            if xb ~= 0
                                            end
                                           [rectx, recty, area, perimeter] =  minboundrect(boundary2(:,2), boundary2(:,1));
                                            maxirectlength = 0;
                                            clear maxirectlengthindex;
                                            maxirectwidth = 0;
                                            clear maxirectwidthindex;
                                            temp1 = zeros(length(rectx)-1,1);
                                            for i = 1:length(rectx)-1
                                                temp1(i) = sqrt((rectx(i)-rectx(i+1))^2 + (recty(i)-recty(i+1))^2);
                                                if temp1(i) > maxirectlength
                                                    maxirectlength = temp1(i);
                                                    maxirectlengthindex = i;
                                                end
                                            end
                                            maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                                            maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                                            middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                                            opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                                            slope = (opposite_middle_point(1)-middle_point(1))/(opposite_middle_point(2)-middle_point(2));
                                        end
                                    end
                                end
                            end
                            compt3 = 0;
                            for op = 1:length(computed_indices3)
                                if computed_indices3(op) ~= 0
                                    clear bounda;
                                    compt2 = compt2 + 1;
                                    compt3 = compt3 + 1;
                                    
                                    if compt3 == 1
                                        compteurfirst = compteurfirst+1;
                                        tempbound = smallB2{computed_indices3(op)};
                                        bounda(:,1)= tempbound(:,1)+box{p}(2);
                                        bounda(:,2)= tempbound(:,2)+box{p}(1);
                                        newBres{indice(p)} = bounda;
                                        newfsci(fsci_leng+compt2) = indice(p);
                                        slopevector(newfsci(fsci_leng+compt2)) = slopevec(computed_indices3(op));
                                        centroid2( newfsci(fsci_leng+compt2),:) = centroid5(computed_indices3(op),:);
                                        newboundarea2( newfsci(fsci_leng+compt2)) = polyarea(bounda(:,2), bounda(:,1));
                                        %                                         longueur_profile
                                        [rectx, recty, area, perimeter] =  minboundrect(bounda(:,2), bounda(:,1));
                                        first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                        second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                        if first < second
                                            width = first;
                                            longueur = second;
                                        else
                                            width = second;
                                            longueur = first;
                                        end
                                        
                                        maxirectlength = 0;
                                        clear maxirectlengthindex;
                                        maxirectwidth = 0;
                                        clear maxirectwidthindex;
                                        temp1 = zeros(length(rectx)-1,1);
                                        for i2 = 1:length(rectx)-1
                                            temp1(i2) = sqrt((rectx(i2)-rectx(i2+1))^2 + (recty(i2)-recty(i2+1))^2);
                                            if temp1(i2) > maxirectlength
                                                maxirectlength = temp1(i2);
                                                maxirectlengthindex = i2;
                                            end
                                        end
                                        maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                                        maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                                        topx = max(rectx);
                                        lowx = min(rectx);
                                        topy = max(recty);
                                        lowy = min(recty);
                                        turningboxxaxis = [lowx topx topx lowx lowx];
                                        turningboxyaxis = [lowy lowy topy topy lowy];
                                        rectlength = topx-lowx;
                                        rectwidth = topy-lowy;
                                        middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                                        opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                                        [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit]= myprofileline(middle_point, opposite_middle_point);
                                        longueur_profile(newfsci(fsci_leng+compt2)) = length_profile;
                                        Xprofiles{newfsci(fsci_leng+compt2)} = xprofile;
                                        Yprofiles{newfsci(fsci_leng+compt2)} = yprofile;
                                        slopevector(newfsci(fsci_leng+compt2)) = slope;
                                        test = round(xprofile);
                                        test2 = round(yprofile);
                                        clear pixelvalue;
                                        clear testy;
                                        clear testx;
                                        if longueur > minimallength
                                            for perp = 1:7
                                                testy{perp} = round((yprofile+(4-perp)*(-1)*deltaxunit)); %ceil
                                                testx{perp} = round((xprofile+(4-perp)*deltayunit));
                                                [testx{perp}, testy{perp}] = checkprofile(testx{perp}, testy{perp}, subimagesizex, subimagesizey);
                                                for l = 1:length(testx{perp})
                                                    pixelvalue(perp,l) = tempim2{subpart}(round(testy{perp}(l)), round(testx{perp}(l)));
                                                end
                                                
                                            end
                                            values = mean(pixelvalue(:,1:l));
                                            clear valuestemp
                                            valuestemp = (conv(values,psi2,'valid'));
                                            [values2(newfsci(fsci_leng+compt2),1), values2(newfsci(fsci_leng+compt2),2)] = max(valuestemp);
                                            [values3(newfsci(fsci_leng+compt2),1), values3(newfsci(fsci_leng+compt2),2)] = min(valuestemp);
                                            
                                            values2(newfsci(fsci_leng+compt2),2) = values2(newfsci(fsci_leng+compt2),2)/length(valuestemp);
                                            values3(newfsci(fsci_leng+compt2),2) = values3(newfsci(fsci_leng+compt2),2)/length(valuestemp);
                                            values4 = (conv(double(values),double(psi),'valid'));
                                            [maxvalues2(newfsci(fsci_leng+compt2)), maxpos(newfsci(fsci_leng+compt2))] = max(values4);
                                            [minvalues2(newfsci(fsci_leng+compt2)), minpos(newfsci(fsci_leng+compt2))] = min(values4);
                                            imtoplot = poly2mask(bounda(:,2), bounda(:,1), subimagesizey, subimagesizex);
                                            
                                            texture(newfsci(fsci_leng+compt2),:) =  nd_texture(tempim2{subpart}, imtoplot, 32);
                                        else
                                            texture(newfsci(fsci_leng+compt2),:) = 0;
                                            values3(newfsci(fsci_leng+compt2),:) = 0;
                                            values2(newfsci(fsci_leng+compt2),:) = 0;
                                            
                                        end
                                        
                                    else
                                        tempbound = smallB2{computed_indices3(op)};
                                        bounda(:,1)= tempbound(:,1)+box{p}(2);
                                        bounda(:,2)= tempbound(:,2)+box{p}(1);
                                        newBres{newBsize+compt2-compteurfirst} = bounda;
                                        newfsci(fsci_leng+compt2) = newBsize+compt2-compteurfirst;
                                        slopevector( newfsci(fsci_leng+compt2)) = slopevec(computed_indices3(op));
                                        centroid2( newfsci(fsci_leng+compt2),:) = centroid5(computed_indices3(op),:);
                                        newboundarea2( newfsci(fsci_leng+compt2)) = polyarea(bounda(:,2), bounda(:,1));
                                        [rectx, recty, area, perimeter] =  minboundrect(bounda(:,2), bounda(:,1));
                                        
                                        first = sqrt((rectx(2)-rectx(1))^2 + (recty(2)-recty(1))^2);
                                        second = sqrt((rectx(3)-rectx(2))^2 + (recty(3)-recty(2))^2);
                                        if first < second
                                            width = first;
                                            longueur = second;
                                        else
                                            width = second;
                                            longueur = first;
                                        end
                                        
                                        maxirectlength = 0;
                                        clear maxirectlengthindex;
                                        maxirectwidth = 0;
                                        clear maxirectwidthindex;
                                        temp1 = zeros(length(rectx)-1,1);
                                        for i2 = 1:length(rectx)-1
                                            temp1(i2) = sqrt((rectx(i2)-rectx(i2+1))^2 + (recty(i2)-recty(i2+1))^2);
                                            if temp1(i2) > maxirectlength
                                                maxirectlength = temp1(i2);
                                                maxirectlengthindex = i2;
                                            end
                                        end
                                        maxirectwidth = temp1(mod(maxirectlengthindex,2)+1);
                                        maxirectwidthindex = mod(maxirectlengthindex,2)+1;
                                        topx = max(rectx);
                                        lowx = min(rectx);
                                        topy = max(recty);
                                        lowy = min(recty);
                                        turningboxxaxis = [lowx topx topx lowx lowx];
                                        turningboxyaxis = [lowy lowy topy topy lowy];
                                        rectlength = topx-lowx;
                                        rectwidth = topy-lowy;
                                        middle_point = [recty(maxirectwidthindex) + (recty(maxirectwidthindex+1)-recty(maxirectwidthindex))/2 rectx(maxirectwidthindex)+ (rectx(maxirectwidthindex+1)-rectx(maxirectwidthindex))/2];
                                        opposite_middle_point = [recty(maxirectwidthindex+2) + (recty(maxirectwidthindex+3)-recty(maxirectwidthindex+2))/2 rectx(maxirectwidthindex+2)+ (rectx(maxirectwidthindex+3)-rectx(maxirectwidthindex+2))/2];
                                        [slope, length_profile, xprofile, yprofile, sigx, sigy, deltaxunit, deltayunit]= myprofileline(middle_point, opposite_middle_point);
                                        longueur_profile(newfsci(fsci_leng+compt2)) = length_profile;
                                        Xprofiles{newfsci(fsci_leng+compt2)} = xprofile;
                                        Yprofiles{newfsci(fsci_leng+compt2)} = yprofile;
                                        slopevector(newfsci(fsci_leng+compt2)) = slope;
                                        test = round(xprofile);
                                        test2 = round(yprofile);
                                        clear pixelvalue;
                                        clear testy;
                                        clear testx;
                                        
                                        for perp = 1:7
                                            testy{perp} = round((yprofile+(4-perp)*(-1)*deltaxunit)); %ceil
                                            testx{perp} = round((xprofile+(4-perp)*deltayunit));
                                            [testx{perp}, testy{perp}] = checkprofile(testx{perp}, testy{perp}, subimagesizex, subimagesizey);
                                            for l = 1:length(testx{perp})
                                                pixelvalue(perp,l) = tempim2{subpart}(round(testy{perp}(l)), round(testx{perp}(l)));
                                            end
                                            
                                        end
                                        if longueur > minimallength
                                            values = mean(pixelvalue(:,1:l));
                                            clear valuestemp
                                            valuestemp = (conv(values,psi2,'valid'));
                                            [values2(newfsci(fsci_leng+compt2),1), values2(newfsci(fsci_leng+compt2),2)] = max(valuestemp);
                                            [values3(newfsci(fsci_leng+compt2),1), values3(newfsci(fsci_leng+compt2),2)] = min(valuestemp);
                                            
                                            values2(newfsci(fsci_leng+compt2),2) = values2(newfsci(fsci_leng+compt2),2)/length(valuestemp);
                                            values3(newfsci(fsci_leng+compt2),2) = values3(newfsci(fsci_leng+compt2),2)/length(valuestemp);
                                            values4 = (conv(double(values),double(psi),'valid'));
                                            [maxvalues2(newfsci(fsci_leng+compt2)), maxpos(newfsci(fsci_leng+compt2))] = max(values4);
                                            [minvalues2(newfsci(fsci_leng+compt2)), minpos(newfsci(fsci_leng+compt2))] = min(values4);
                                            imtoplot = poly2mask(bounda(:,2), bounda(:,1), subimagesizey, subimagesizex);
                                            
                                            texture(newfsci(fsci_leng+compt2),:) =  nd_texture(tempim2{subpart}, imtoplot, 32);
                                            
                                        else
                                            texture(newfsci(fsci_leng+compt2),:) = 0;
                                            values3(newfsci(fsci_leng+compt2),:) = 0;
                                            values2(newfsci(fsci_leng+compt2),:) = 0;
                                            
                                            
                                        end
                                        
                                        
                                    end
                                end
                            end
                            working_indices(find(working_indices == indice(p))) = 0;
                        end
                        
                        
                    end
                    
                    
                    clear centroid;
                    clear newB
                    clear final_single_cell_indices;
                    clear newboundarea;
                    centroid = centroid2;
                    newB = newBres;
                    final_single_cell_indices = newfsci;
                    newboundarea = newboundarea2;
                    savefileName = fullfile(savefiledirectory1, sprintf('start_%s_%s_%s_%s_%s_part%d_variables_resegmented.mat',starttime ,fluofilter , position, date, picnumber, subpart));
                    save(savefileName, 'newB', 'final_single_cell_indices','working_indices', 'slopevector','newboundarea', 'maxvalues2', 'minvalues2','centroid', 'longueur_profile', 'texture', 'back_ground', 'round_cells', 'highway_indices', 'level2');
                end
           end
        end
    end
end

